var createError = require('http-errors');
var express = require('express');
var path = require('path');
var cookieParser = require('cookie-parser');
var logger = require('morgan');
const {resolve} = require('path')

var indexRouter = require('./routes/index');
var helloRouter = require('./routes/hello');
var entryRouter = require('./routes/entry');
var batchInputRouter = require('./routes/batchInput');
var merProfileRouter = require('./routes/merProfile');

var app = express();

//设置跨域访问
app.all('*', function(req, res, next) {
  res.header("Access-Control-Allow-Origin", "*");
  res.header("Access-Control-Allow-Headers", "Content-Type,Content-Length, Authorization, Accept,X-Requested-With");
  res.header("Access-Control-Allow-Methods","PUT,POST,GET,DELETE,OPTIONS");
  res.header("X-Powered-By",' 3.2.1')
  if(req.method=="OPTIONS") res.send(200);/*让options请求快速返回*/
  else  next();
});

// view engine setup
app.set('views', path.join(__dirname, 'views'));
app.set('view engine', 'jade');

app.use(logger('dev'));
app.use(express.json());
app.use(express.urlencoded({ extended: false }));
app.use(cookieParser());
app.use(express.static(path.join(__dirname, 'public')));

app.use('/', indexRouter);
app.use('/api/', helloRouter);
app.use('/api/v1/entry', entryRouter);
app.use('/api/v1/batchInput', batchInputRouter);
app.use('/api/v1/merProfile', merProfileRouter);

// catch 404 and forward to error handler
app.use(function(req, res, next) {
  next(createError(404));
});

// error handler
app.use(function(err, req, res, next) {
  // set locals, only providing error in development
  res.locals.message = err.message;
  res.locals.error = req.app.get('env') === 'development' ? err : {};

  // render the error page
  res.status(err.status || 500);
  res.render('error');
});

var Merchant = require('./utils/sdk/adapay-sdk/merchant/Merchant')
// 设置基本参数
let config = {}
config.debug = true
config.prod_mode = true

config.connect_timeout = 60000
config.log_file_path = resolve("./logs/")
config.log_console_enable = true
Merchant.set_config(config)
Merchant.set_merchant_path(resolve('../utils/merchantConfig.json'))

module.exports = app;

// http://192.168.15.97:30050/
// http://192.168.16.89:30050/
// http://192.168.16.90:30050/
